module Rake
  module Opt
    class Chore < Rake::Task

      # Overrides Rake::Task#invoke to execute even if already invoked
      def invoke_with_call_chain(task_args, invocation_chain) # :nodoc:
        new_chain = InvocationChain.append(self, invocation_chain)
        @lock.synchronize do
          if application.options.trace
            application.trace "** Invoke #{name} #{format_trace_flags}"
          end
          @already_invoked = true
          invoke_prerequisites(task_args, new_chain)
          execute(task_args) if needed?
        end
      rescue Exception => ex
        add_chain_to(ex, new_chain)
        raise ex
      end

    end
  end
end

require_relative 'chore/patches.rb'
